#include "common.h"
void EuObject::cne(EuObject *obj)
{
   if (type == INTEGER)
   {
      if (obj->type == INTEGER)
      {
         setRv(iVal != obj->iVal);
      } else if (obj->type == ATOM)
      {
         setRv((double)iVal != obj->aVal);
      } else {
        printf("can't cne integer, sequence.\n");
        abort();
      }
   } else if (type == ATOM)
   {
      if (obj->type == ATOM)
      {
         setRv(aVal != obj->aVal);
      } else if (obj->type == INTEGER)
      {
         setRv(aVal != (double)obj->iVal);
      } else {
        printf("can't cne atom, sequence.\n");
        abort();
      }
   } else {
     printf("can't cne sequences.\n");
   }
}