#ifndef RANDOM_H
#define RANDOM_H
#define IA 16807.0
#define I15 32768.0
#define I16 65536.0
#define IP 2147483647
#define DK 1.0 / IP
double IX = (double)2000000000.0;
double myrandom()
{
	double IXH, IXA, LFTL, IFH, K;
	IXH = (int)(IX / I16);
	IXA = (IX - IXH * I16) * IA;
	LFTL = (int)(IXA / I16);
	IFH = IXH * IA + LFTL;
	K = (int)(IFH / I15);
	IX = (((IXA - LFTL * I16) - IP) + (IFH - K * I15) * I16) + K;
	if (IX < 0.0)
	{
		IX = IX + IP;
	}
	return IX * DK;
}
#endif
