-- Euphoria Assembly opcode generator by Jeffrey Fielding (JJProg@cyberbury.net)
include instruct.e
include file.e
function getLst(sequence s)
    sequence r
    r = "{"
    for i = 1 to length(s)-1  do
	if s[i] = 1 then
	    r &= "VAL,"
	else
	    r &= "VAR,"
	end if
    end for
    if s[length(s)] = 1 then
	r &= "VAL}"
    else
	r &= "VAR}"
    end if
    return r
end function
integer n, f, flg
sequence t
f = open("opcodes.e","w")
puts(f,"-- Euphoria Assembly Opcodes by Jeffrey Fielding (JJProg@cyberbury.net)\n")
puts(f,"global constant VAL = 1,\n")
puts(f,"                VAR = 2\n")
puts(f,"global constant OPCODES = {")
n = 0
for i = 1 to length(INSTRUCTIONS) do
    if INSTRUCTIONS[i][2] = 0 then
	printf(f,"{\"" & INSTRUCTIONS[i][1] & "\",#%x,{}},\n",n)
	n += 1
    else
	t = repeat(1,INSTRUCTIONS[i][2])
	while t[INSTRUCTIONS[i][2]] < 3 do
	    flg = 1
	    for j = 1 to INSTRUCTIONS[i][2] do
		if t[j] = 2 and INSTRUCTIONS[i][3][j] = 0 then
		    flg = 0
		    exit
		end if
	    end for
	    if flg then
		printf(f,"{\"" & INSTRUCTIONS[i][1] & "\",#%x," & getLst(t) & "},\n",n)
		n += 1
	    end if
	    t[1] += 1
	    for j = 1 to length(t)-1 do
		if t[j] = 3 then
		    t[j] = 1
		    t[j+1] += 1
		end if
	    end for
	end while
    end if
end for
flg = seek(f,where(f)-3)
puts(f,'}')
close(f)
