-- EuOS Bytecode Value Reader/Writer by Jeffrey Fielding (JJProg@cyberbury.net)
include machine.e
global constant SEQUENCE = 0,
		BYTE = 1,
		WORD = 2,
		DWORD = 3,
		FLOAT32 = 4,
		NEGBYTE = 5,
		NEGWORD = 6,
		NEGDWORD = 7
global procedure WriteValue(integer f, object data)
    if sequence(data) then
	puts(f,SEQUENCE)
	WriteValue(f,length(data))
	for i = 1 to length(data) do
	    WriteValue(f,data[i])
	end for
    elsif remainder(data,1) = 0 and data < power(2,32) then
	if data < 0 then
	    data = -data
	    if data < 256 then
		puts(f,{NEGBYTE,data})
	    elsif data < 65536 then
		puts(f,{NEGWORD,remainder(data,256),floor(data/256)})
	    else
		puts(f,{NEGDWORD,remainder(data,256)})
		data = floor(data/256)
		puts(f,remainder(data,256))
		data = floor(data/256)
		puts(f,remainder(data,256))
		data = floor(data/256)
		puts(f,data)
	    end if
	else
	    if data < 256 then
		puts(f,{BYTE,data})
	    elsif data < 65536 then
		puts(f,{WORD,remainder(data,256),floor(data/256)})
	    else
		puts(f,{DWORD,remainder(data,256)})
		data = floor(data/256)
		puts(f,remainder(data,256))
		data = floor(data/256)
		puts(f,remainder(data,256))
		data = floor(data/256)
		puts(f,data)
	    end if
	end if
    else
	puts(f,FLOAT32 & atom_to_float32(data))
    end if
end procedure
global function ReadValue(integer f)
    integer typ
    object val, t
    typ = getc(f)
    if typ = SEQUENCE then
	t = ReadValue(f)
	val = repeat(0,t)
	for i = 1 to t do
	    val[i] = ReadValue(f)
	end for
    elsif typ = BYTE then
	val = getc(f)
    elsif typ = WORD then
	val = getc(f)+(getc(f)*256)
    elsif typ = DWORD then
	val = getc(f)+(getc(f)*256)+(getc(f)*256*256)+(getc(f)*256*256*256)
    elsif typ = NEGBYTE then
	val = -getc(f)
    elsif typ = NEGWORD then
	val = -(getc(f)+(getc(f)*256))
    elsif typ = NEGDWORD then
	val = -(getc(f)+(getc(f)*256)+(getc(f)*256*256)+(getc(f)*256*256*256))
    elsif typ = FLOAT32 then
	val = float32_to_atom({getc(f),getc(f),getc(f),getc(f)})
    end if
    return val
end function
