#include "common.h"
#define SEQUENCE_BYTE 0
#define BYTE 1
#define WORD 2
#define DWORD 3
#define FLOAT32 4
#define NEGBYTE 5
#define NEGWORD 6
#define NEGDWORD 7
long readInt(FILE *f)
{
   int type;
   type = fgetc(f);
   if (type == BYTE)
   {
      return (long)fgetc(f);
   } else if (type == WORD) {
      return ((long)fgetc(f)) + ((long)fgetc(f)*256);
   } else if (type == DWORD) {
      return ((long)fgetc(f)) + ((long)fgetc(f)*256) + ((long)fgetc(f)*65536) + ((long)fgetc(f)*16777216);
   } else if (type == NEGBYTE)
   {
      return -((long)fgetc(f));
   } else if (type == NEGWORD) {
      return -(((long)fgetc(f)) + ((long)fgetc(f)*256));
   } else if (type == NEGDWORD) {
      return -(((long)fgetc(f)) + ((long)fgetc(f)*256) + ((long)fgetc(f)*65536) + ((long)fgetc(f)*16777216));
   }
}
void EuObject::ReadValue(FILE *f)
{
   int typ;
   float fval;
   EuObject *o;
   long s;
   typ = fgetc(f);
   if (typ == BYTE)
   {
      iVal =  (long)fgetc(f);
   } else if (typ == WORD) {
      iVal =  ((long)fgetc(f)) + ((long)fgetc(f)*256);
   } else if (typ == DWORD) {
      iVal =  ((long)fgetc(f)) + ((long)fgetc(f)*256) + ((long)fgetc(f)*65536) + ((long)fgetc(f)*16777216);
   } else if (typ == NEGBYTE)
   {
      iVal =  -((long)fgetc(f));
   } else if (typ == NEGWORD) {
      iVal =  -(((long)fgetc(f)) + ((long)fgetc(f)*256));
   } else if (typ == NEGDWORD) {
      iVal =  -(((long)fgetc(f)) + ((long)fgetc(f)*256) + ((long)fgetc(f)*65536) + ((long)fgetc(f)*16777216));
   } else if (typ == FLOAT32)
   {
      type = ATOM;
      fread(&fval,sizeof(float),1,f);
      aVal = (double)fval;
   } else {
      size = readInt(f);
      if (type == SEQUENCE)
      {
         if (size > actualSize)
         {
            EuObject *newElements = (EuObject *)realloc(children,sizeof(EuObject)*size);
            actualSize = size;
            if (newElements != children)
               delete [] children;
            children = newElements;
         }
      } else {
        children = new EuObject[size];
        actualSize = size;
        type = SEQUENCE;
      }
      type = SEQUENCE;
      for (long i = 0; i < size; i++)
          children[i].ReadValue(f);
   }
}
